import React from 'react';
export interface FocoRenderProps {
    className?: string;
    style?: React.CSSProperties;
    onMouseDown: React.MouseEventHandler;
    onFocus: React.FocusEventHandler;
    onTouchStart: React.TouchEventHandler;
}
export declare type FocoRenderType = (props: FocoRenderProps) => React.ReactNode;
export interface FocoProps {
    onClickOutside?: (event: MouseEvent | TouchEvent) => void;
    onFocusOutside?: (event: FocusEvent) => void;
    children?: FocoRenderType | React.ReactNode;
    className?: string;
    style?: React.CSSProperties;
    component?: any;
    render?: FocoRenderType;
}
export default class Foco extends React.Component<FocoProps> {
    private clickCaptured;
    private focusCaptured;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): any;
    private renderComponent;
    private getProps;
    private init;
    private flush;
    private documentClick;
    private innerClick;
    private documentFocus;
    private innerFocus;
}
